#pragma once
#include <luna/Bitmap.h>
#include <luna/OwnedPtr.h>
#include <luna/Result.h>

class UserVM
{
  public:
    UserVM(void* base, usize size);
    ~UserVM();

    Result<u64> alloc_one_page();
    Result<u64> alloc_several_pages(usize count);

    Result<bool> free_one_page(u64 address);
    Result<bool> free_several_pages(u64 address, usize count);

    static Result<OwnedPtr<UserVM>> try_create();

  private:
    Result<bool> try_expand(usize size = 160);
    Bitmap m_bitmap;
};
